// This file is generated from lrpattern.nw
//
// main.cpp - main programm for small smtp demon
//
#include "ssmtpdi.h"

#include <iostream.h>
#include <string.h>

char   lineBuf[128];
char * diagMessage;
int    terminate;

void processLine(CssmtpdContext & act)
{
  if (!strncasecmp("mail from:",lineBuf,10))
     (act.GetState())->MailEvent(act);
  else if (!strncasecmp("rcpt to:",lineBuf,8))
     (act.GetState())->RcptEvent(act);
  else if (!strncasecmp("helo",lineBuf,4))
     (act.GetState())->HeloEvent(act);
  else if (!strncasecmp("data",lineBuf,4))
     (act.GetState())->DataEvent(act);
  else if (!strncasecmp("quit",lineBuf,4))
     (act.GetState())->QuitEvent(act);
}

void CssmtpdContext::UnexpectedEvent(const char * state,
                                    const char * event)
{
  cout << "500 unexpected event: "
       << event
       << " in state: "
       << state
       << endl;
}

void CssmtpdContext::SendDiagnosticMessage()
{
  cout << diagMessage << endl;
}

void CssmtpdContext::ClearAllTables()
{
}

void CssmtpdContext::ReceiveData()
{
  cout << "250 send data, end with single '.'" << endl;
  while (cin &&
         0 < cin.getline(lineBuf,128))
    if (!strcmp(lineBuf, "."))
      break;
  diagMessage =  "250 data received";
}

void CssmtpdContext::CheckRecipientAddress()
{
  diagMessage = "250 recipient ok";
}

void CssmtpdContext::CheckMailAddress()
{
  diagMessage = "250 mail address ok";
}

void CssmtpdContext::RegisterTheDomain()
{
  diagMessage = "250 Helo you";
}

void CssmtpdContext::SendGreetingMessage()
{
  cout << "250 ssmtpd ready" << endl;
}

void CssmtpdContext::TerminateTheProgram()
{
  terminate = 1;
  cout << "250 good bye" << endl;
}

void main(int, char **)
{
  CssmtpdContext demon;

  (demon.GetState())->OkEvent(demon);

  while (cin                          &&
         !terminate                   &&
         0 < cin.getline(lineBuf,128))
    processLine(demon);
}
